//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%435E8A1500CB.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%435E8A1500CB.cm

//## begin module%435E8A1500CB.cp preserve=no
//## end module%435E8A1500CB.cp

//## Module: RandomLuxAdapter%435E8A1500CB; Package body
//## Subsystem: XSUtil::Numerics%41E6D0F3003C
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUtil/Numerics/RandomLuxAdapter.cxx

//## begin module%435E8A1500CB.additionalIncludes preserve=no
//## end module%435E8A1500CB.additionalIncludes

//## begin module%435E8A1500CB.includes preserve=yes
//## end module%435E8A1500CB.includes

// RandomLux
#include <XSUtil/Numerics/RandomLux.h>
// RandomLuxAdapter
#include <XSUtil/Numerics/RandomLuxAdapter.h>


//## begin module%435E8A1500CB.declarations preserve=no
//## end module%435E8A1500CB.declarations

//## begin module%435E8A1500CB.additionalDeclarations preserve=yes
//## end module%435E8A1500CB.additionalDeclarations


//## Modelname: XSUtil::Numerics%3F6F5A7603D4
namespace Numerics {
    //## begin Numerics%3F6F5A7603D4.initialDeclarations preserve=yes
    //## end Numerics%3F6F5A7603D4.initialDeclarations

    // Class Numerics::RandomLuxAdapter 

    RandomLuxAdapter::RandomLuxAdapter()
      //## begin RandomLuxAdapter::RandomLuxAdapter%435E640000EF_const.hasinit preserve=no
      //## end RandomLuxAdapter::RandomLuxAdapter%435E640000EF_const.hasinit
      //## begin RandomLuxAdapter::RandomLuxAdapter%435E640000EF_const.initialization preserve=yes
      //## end RandomLuxAdapter::RandomLuxAdapter%435E640000EF_const.initialization
    {
      //## begin Numerics::RandomLuxAdapter::RandomLuxAdapter%435E640000EF_const.body preserve=yes
       m_generator = new RandomLux();
      //## end Numerics::RandomLuxAdapter::RandomLuxAdapter%435E640000EF_const.body
    }


    RandomLuxAdapter::~RandomLuxAdapter()
    {
      //## begin Numerics::RandomLuxAdapter::~RandomLuxAdapter%435E640000EF_dest.body preserve=yes
       delete m_generator;
      //## end Numerics::RandomLuxAdapter::~RandomLuxAdapter%435E640000EF_dest.body
    }



    //## Other Operations (implementation)
    void RandomLuxAdapter::initialize (int seed, const std::vector<Real>& extraPars)
    {
      //## begin Numerics::RandomLuxAdapter::initialize%435E8952027C.body preserve=yes
       int luxLevel = 3;

       if (extraPars.size())
          luxLevel = static_cast<int>(extraPars[0]);
       m_generator->rluxgo(luxLevel, seed, 0, 0);
      //## end Numerics::RandomLuxAdapter::initialize%435E8952027C.body
    }

    void RandomLuxAdapter::getRandom (std::vector<Real>& randNumbers, const std::vector<Real>& extraPars)
    {
      //## begin Numerics::RandomLuxAdapter::getRandom%435EAACF01F0.body preserve=yes
       int length = static_cast<int>(randNumbers.size());
       float *tmpFloats = new float[length];
       m_generator->ranlux(tmpFloats, length);
       for (int i=0; i<length; ++i)
       {
          randNumbers[i] = static_cast<Real>(tmpFloats[i]);
       }
       delete [] tmpFloats;
      //## end Numerics::RandomLuxAdapter::getRandom%435EAACF01F0.body
    }

    void RandomLuxAdapter::getRandom (float* randNumbers, int length, const std::vector<Real>& extraPars)
    {
      //## begin Numerics::RandomLuxAdapter::getRandom%435EAB400062.body preserve=yes
       m_generator->ranlux(randNumbers, length);
      //## end Numerics::RandomLuxAdapter::getRandom%435EAB400062.body
    }

    void RandomLuxAdapter::getRandom (Real* randNumbers, int length, const std::vector<Real>& extraPars)
    {
      //## begin Numerics::RandomLuxAdapter::getRandom%435EAB7E0131.body preserve=yes
       float *tmpFloats = new float[length];
       m_generator->ranlux(tmpFloats, length);
       for (int i=0; i<length; ++i)
       {
          randNumbers[i] = static_cast<Real>(tmpFloats[i]);
       }
       delete [] tmpFloats;
      //## end Numerics::RandomLuxAdapter::getRandom%435EAB7E0131.body
    }

    // Additional Declarations
      //## begin Numerics::RandomLuxAdapter%435E640000EF.declarations preserve=yes
      //## end Numerics::RandomLuxAdapter%435E640000EF.declarations

} // namespace Numerics

//## begin module%435E8A1500CB.epilog preserve=yes
//## end module%435E8A1500CB.epilog
